#pragma clang diagnostic push
#pragma ide diagnostic ignored "performance-unnecessary-value-param"
#pragma ide diagnostic ignored "readability-convert-member-functions-to-static"

#include "controllers.h"
#include "dto/dto.h"

namespace api {
    void user::info(req_type req, cbk_type cbk) {
        db::User user = dto::get_user(req);
        cbk(dto::Responses::get_user_info_res(
                user.getValueOfName(),
                user.getValueOfGitlab() != 0,
                db::User_getEnumTfaType(user) != db::tfaTypes::NONE)
        );
    }

    void user::delete_user(req_type req, cbk_type cbk) {
        db::MapperUser user_mapper(drogon::app().getDbClient());

        msd::channel<std::string> chan;
        db::User user = dto::get_user(req);
        auth::revoke_all(user);

        std::unique_lock lock(*fs::get_user_mutex(user.getValueOfId()));

        fs::delete_node((fs::get_node(user.getValueOfRootId())).value(), chan, true);
        user_mapper.deleteOne(user);

        cbk(dto::Responses::get_success_res());
    }
}
#pragma clang diagnostic pop